Friend Class MultiColumnList

	Inherits FarPoint.Win.Spread.FpSpread
	Implements FarPoint.Win.Spread.CellType.ISubEditor
	Public Event ValueChanged As EventHandler Implements FarPoint.Win.Spread.CellType.ISubEditor.ValueChanged
	Public Event CloseUp As EventHandler Implements FarPoint.Win.Spread.CellType.ISubEditor.CloseUp
	Dim myForm As Form
	Dim st, f As String


	Friend Class MouseMessageFilter

		Implements IMessageFilter

		Public list As MultiColumnList

		Public Sub New(ByVal list As MultiColumnList)
			Me.list = list
		End Sub		  'New

		Public Function PreFilterMessage(ByRef m As Message) As Boolean Implements IMessageFilter.PreFilterMessage
			' Blocks all the messages relating to the left mouse button.
			Try
				If m.Msg = 32 Then
					If m.WParam.ToInt32() = 531 Then
						Return True
					Else
						Return False
					End If
				End If
				Return False
			Catch ex As Exception
				MsgBox(ex.ToString)
			End Try

		End Function		  'PreFilterMessage

	End Class	   'MouseMessageFilter

	Friend filter As MouseMessageFilter

	Public Sub New(ByVal ds_ As DataSet, ByVal MainForm As Form, ByVal str As String)

		Try

			Me.myForm = MainForm
			filter = New MouseMessageFilter(Me)
			Application.AddMessageFilter(filter)
			Me.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.Never
			Me.RowSplitBoxPolicy = FarPoint.Win.Spread.SplitBoxPolicy.Never
			Me.ColumnSplitBoxPolicy = FarPoint.Win.Spread.SplitBoxPolicy.Never

			'me.
            Dim z As Integer
            Dim s As New FarPoint.Win.Spread.SheetView
			Dim dsFiltered As New DataSet
			Dim ds1 As New DataSet

            s.ColumnCount = ds_.Tables(0).Columns.Count
            s.DataSource = ds_.Tables(0)
            s.RowCount = ds_.Tables(0).Rows.Count
			s.OperationMode = FarPoint.Win.Spread.OperationMode.SingleSelect


			Me.Sheets.Add(s)
            s.Columns(0).Width = 100
            s.Columns(1).Width = 100
            s.Columns(2).Width = 100
            s.Columns(3).Width = 100

			'Me.CellDoubleClick += New CellClickEventHandler(Me.CellDoubleClicked)
			AddHandler MyBase.CellDoubleClick, AddressOf Me.CellDoubleClicked
			'Me.KeyDown += New KeyEventHandler(Me.SpreadKeyDown)
			AddHandler MyBase.KeyDown, AddressOf Me.SpreadKeyDown




		Catch ex As Exception
			MsgBox(ex.ToString)
		End Try
	End Sub	   'New

	Private Sub CellDoubleClicked(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.CellClickEventArgs)

		Try

			If Me.ActiveSheet.RowCount = 0 Then Exit Sub

			RaiseEvent ValueChanged(Me, EventArgs.Empty)
			RaiseEvent CloseUp(Me, EventArgs.Empty)

            Form1.FpSpread1.EditModeReplace = True
            Form1.FpSpread1.EditMode = False


		Catch ex As Exception
			MsgBox(ex.ToString)
		End Try

	End Sub	   'CellDoubleClicked

	Private Sub SpreadKeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)

		Try

			If e.KeyCode = Keys.Enter Then

				If Me.ActiveSheet.RowCount = 0 Then Exit Sub

				RaiseEvent ValueChanged(Me, EventArgs.Empty)
				RaiseEvent CloseUp(Me, EventArgs.Empty)

                Form1.FpSpread1.EditModeReplace = True
                Form1.FpSpread1.EditMode = False            

			End If

		Catch ex As Exception
			MsgBox(ex.ToString)
		End Try

	End Sub	   'SpreadKeyDown

	Public Function GetLocation(ByVal rect As Rectangle) As Point Implements FarPoint.Win.Spread.CellType.ISubEditor.GetLocation
		Try
			Return Point.Empty
		Catch ex As Exception
			MsgBox(ex.ToString)
		End Try
	End Function	   'GetLocation

	Public Function GetSubEditorControl() As Control Implements FarPoint.Win.Spread.CellType.ISubEditor.GetSubEditorControl
		Try
			Return Me
		Catch ex As Exception
            MsgBox(ex.ToString)
            Return Nothing
		End Try
	End Function	   'GetSubEditorControl

	Public Function GetValue() As Object Implements FarPoint.Win.Spread.CellType.ISubEditor.GetValue
		Try
			Return ActiveSheet.GetValue(ActiveSheet.ActiveRowIndex, 0)
		Catch ex As Exception
            MsgBox(ex.ToString)
            Return Nothing
		End Try
	End Function	   'GetValue

	Public Sub SetValue(ByVal value As Object) Implements FarPoint.Win.Spread.CellType.ISubEditor.SetValue
		Try
			'ActiveSheet.SetActiveCell(CStr(value).ToString, 0)
		Catch ex As Exception
			MsgBox(ex.ToString)
		End Try

	End Sub	   'SetValue

    Public Overloads Function GetPreferredSize() As Size Implements FarPoint.Win.Spread.CellType.ISubEditor.GetPreferredSize
        Try
            Return New Size(700, 220)
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Function       'GetPreferredSize

    Public Class MultiColumnDropDownCellType

        Inherits FarPoint.Win.Spread.CellType.EditBaseCellType
        'Inherits FarPoint.Win.Spread.CellType.ComboBoxCellType

        Dim myForm As Form

        Public Sub New(ByVal MainForm As Form, ByVal ds_ As DataSet, ByVal s As String)

            Try
                Me.myForm = MainForm
                SubEditor = New MultiColumnList(ds_, Me.myForm, s)
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try

        End Sub    'New

        Public Overrides Function IsReservedLocation(ByVal g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal rc As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal zoomFactor As Single) As Object
            Try
                Dim rectButton As New Rectangle(rc.X + rc.Width - SystemInformation.VerticalScrollBarWidth, rc.Y, SystemInformation.VerticalScrollBarWidth, rc.Height)
                If rectButton.Contains(New Point(x, y)) Then
                    Return Me
                Else
                    Return Nothing
                End If
            Catch ex As Exception
                MsgBox(ex.ToString)
                Return Nothing
            End Try

        End Function       'IsReservedLocation

        Public Overrides Function GetEditorControl(ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal zoomFactor As Single) As Control

            Try
                Dim c As Control = MyBase.GetEditorControl(appearance, zoomFactor)
                CType(c, FarPoint.Win.Spread.CellType.GeneralEditor).ButtonStyle = FarPoint.Win.ButtonStyle.DropDown
                CType(c, FarPoint.Win.Spread.CellType.GeneralEditor).ControlType = FarPoint.Win.ControlType.Normal
                CType(c, FarPoint.Win.Spread.CellType.GeneralEditor).CharacterCasing = CharacterCasing.Upper
                CType(c, FarPoint.Win.Spread.CellType.GeneralEditor).CharacterSet = FarPoint.Win.Spread.CellType.CharacterSet.Ascii

                Return c

            Catch ex As Exception
                MsgBox(ex.ToString)
                Return Nothing
            End Try

        End Function       'GetEditorControl

        Public Overrides Sub PaintCell(ByVal g As Graphics, ByVal r As Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single)

            Try

                Dim newR As New Rectangle(r.X, r.Y, r.Width - SystemInformation.VerticalScrollBarWidth, r.Height)
                ''Dim rm As New System.Resources.ResourceManager(GetType(FarPoint.Win.IElement))


                Dim b As New FarPoint.Win.ButtonElement
                'b.Border = New FarPoint.Win.BevelBorder(FarPoint.Win.BevelBorderType.Raised, SystemColors.ControlLightLight, SystemColors.ControlDark, 1)
                ''b.ForegroundImage = New FarPoint.Win.Picture(CType(rm.GetObject("dropDown"), System.Drawing.Image), FarPoint.Win.RenderStyle.StretchAndScale, Color.Magenta, FarPoint.Win.HorizontalAlignment.Center, FarPoint.Win.VerticalAlignment.Center)
                ''b.ForegroundImage = New FarPoint.Win.Picture(CType(rm.GetObject("dropDown"), System.Drawing.Image), FarPoint.Win.RenderStyle.StretchAndScale, Color.Magenta, FarPoint.Win.HorizontalAlignment.Center, FarPoint.Win.VerticalAlignment.Center)
                ControlPaint.DrawComboButton(g, newR, ButtonState.Normal)
                Dim buttonRect As New Rectangle(r.X + r.Width - SystemInformation.VerticalScrollBarWidth, r.Y, SystemInformation.VerticalScrollBarWidth, r.Height)

                MyBase.PaintCell(g, newR, appearance, value, isSelected, isLocked, zoomFactor)
                b.OnPaintBackground(g, buttonRect)
                'b.OnPaint(g, buttonRect)

                'ControlPaint.DrawComboButton(g, newR, ButtonState.All)
                'ComboBoxRenderer.DrawDropDownButton(g, newR, Windows.Forms.VisualStyles.ComboBoxState.Normal)
                'ComboBoxRenderer.DrawTextBox(g, newR, Windows.Forms.VisualStyles.ComboBoxState.Normal)

            Catch ex As Exception
                MsgBox(ex.ToString)

            End Try

        End Sub    'PaintCell

        Public Overrides Sub ShowSubEditor()

            Try
                MyBase.ShowSubEditor()

            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try


        End Sub

        'Public Sub GetFocus()

        '    Try
        '        'MyBase.SubEditor.GetSubEditorControl.Focus()
        '    Catch ex As Exception
        '        MsgBox(ex.ToString)
        '    End Try
        'End Sub

    End Class 'MultiColumnDropDownCellType

End Class 'MultiColumnList


