﻿
Public Class Form1

    Public ds_ As DataSet

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try

            ds_ = PopulateDataSet()
            BuildSelectedProductSpread()

        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Sub

    Public Sub BuildSelectedProductSpread()

        Try

            Dim im As FarPoint.Win.Spread.InputMap

            im = FpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
            im.Put(New FarPoint.Win.Spread.Keystroke(Keys.Tab, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

            im = FpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenFocused)
            im.Put(New FarPoint.Win.Spread.Keystroke(Keys.Tab, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

            Dim fpList As New MultiColumnList.MultiColumnDropDownCellType(Me, ds_, "")

            FpSpread1.Sheets(0).Columns(0).CellType = fpList
            FpSpread1.EditModeReplace = False

        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Sub

    Public Function PopulateDataSet() As DataSet

        Dim ds As DataSet = New DataSet("testDS")
        Dim dt As DataTable = New DataTable("testDT")
        Dim dr As DataRow
        Dim i As Integer

        Try


            dt.Columns.Add("ProductID")
            dt.Columns.Add("Description")
            dt.Columns.Add("Quantity")
            dt.Columns.Add("Weight")
            ds.Tables.Add(dt)

            For i = 0 To 20

                dr = ds.Tables(0).NewRow
                dr("ProductID") = "Product ID " & i
                dr("Description") = "Product " & Chr(i + 65)
                dr("Quantity") = i * 2
                dr("Weight") = CInt(i * 3 / 5)
                dt.Rows.Add(dr)

            Next

            Return ds

        Catch ex As Exception
            MsgBox(ex.ToString)
            Return Nothing
        End Try
    End Function

    Protected Overrides Function ProcessDialogKey(ByVal keyData As System.Windows.Forms.Keys) As Boolean

        Try

            If keyData = Keys.Tab Then

                If TypeOf FpSpread1.Sheets(0).ActiveCell.CellType Is MultiColumnList.MultiColumnDropDownCellType And FpSpread1.EditMode = True Then

                    Dim fp As FarPoint.Win.Spread.FpSpread
                    Dim fpList As MultiColumnList.MultiColumnDropDownCellType
                    fpList = FpSpread1.Sheets(0).ActiveCell.CellType
                    fp = fpList.SubEditor.GetSubEditorControl()

                    fp.Sheets(0).SetActiveCell(0, 0)
                    fp.Focus()

                    Dim sel As FarPoint.Win.Spread.Model.ISheetSelectionModel
                    sel = fp.Sheets(0).Models.Selection
                    sel.AddSelection(0, -1, 1, -1)

                End If

            End If


        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Function

    Public Sub FpSpread1_EditChange(ByVal sender As System.Object, ByVal e As FarPoint.Win.Spread.EditorNotifyEventArgs) Handles FpSpread1.EditChange

        Try

            Select Case e.Column
                Case 0

                    Select Case e.Row
                        Case Is > 0
                            If IsNothing(FpSpread1.ActiveSheet.GetValue(e.Row - 1, 0)) Then
                                FpSpread1.ActiveSheet.SetValue(e.Row, 0, Nothing)
                                Exit Sub
                            End If
                    End Select

                    Dim fpList As New MultiColumnList.MultiColumnDropDownCellType(Me, ds_, e.EditingControl.Text.ToString)
                    FpSpread1.ActiveSheet.Cells(e.Row, e.Column).CellType = fpList
                    FpSpread1.EditModeReplace = False
                    FpSpread1.EditMode = True
                    fpList.ShowSubEditor()

            End Select

        Catch ex As Exception
            MsgBox(ex.ToString)

        End Try
    End Sub


End Class

